#![feature(box_syntax, box_patterns)]
extern crate prusti_contracts;

struct Point {
  x: i32, y: i32
}

// Postconditions needed: what changes and how? What does not?
#[ensures="true"]
#[ensures="true"]
fn shift_x(p: &mut Point, s: i32) {
  p.x = p.x + s
}

struct Route { //list of Points
  current: Point,
  rest: Option<Box<Route>>
}

#[pure]
// Postcondition needed: what do we know about result (in all cases)?
#[ensures="true"]
fn len(r: &Route) -> i32 {
  1 + match r.rest {
    Some(box ref q) => len(q),
    None => 0
  }
}

#[pure]
// Precondition needed: what do we require about n?
#[requires="true"]
fn get_nth_x(r: &Route, n: i32) -> i32 {
  // to fill in
}


// Precondition: what is required about n?
#[requires="true"]
// Postcondition: len doesn't change
#[ensures="true"]
// Postcondition: one point's x coordinate has changed
#[ensures="true"]
// Postcondition: other points' x coordinates have not changed
#[ensures="true"]
fn shift_nth_x(r: &mut Route, n: i32, s:i32) {
  // to fill in
}

// TASK A: fill in appropriate specifications for the functions above this line, such that they verify.




// TASK B: uncomment the function below, and add an appropriate specification to it.
// Then, reimplement a new version of shift_nth_x above by simply calling this function and shift_x 
// appropriately. You should not need to change the *specification* of shift_nth_x; only its body.
// Note that this means that the refactoring is opaque for the verification of callers of shift_nth_x

/*
// Precondition: n values
#[requires="true"]
// Postcondition: what is the *current* x coordinate of result?
#[ensures="true"]
// Postcondition: what *will* the x coordinates of the points in r be *after* the result expires?
// Hint: you need a pledge to express this.
#[ensures="true"]
fn borrow_nth(r:&mut Route, n: i32) -> &mut Point {
  // to fill in
}

*/




// dummy main function (for compilation)
fn main() {}
