#![feature(box_patterns, box_syntax)]
extern crate prusti_contracts;


struct List {
    val: i32,
    next: Option<Box<List>>
}

fn client(a: &mut List, b: &mut List) {
    let old_len = b.len();
    append(a, 100); // append spec modified w.r.t. sorted
    assert!(b.len() == old_len);
}
 


 

impl List {

    #[pure] // can be used in specifications
    // TODO: add spec (post)
    fn len(&self) -> usize {
      match self.next {
        None => 1,
        Some(box ref tail) => 1 + tail.len()
      }
    }

    // TODO: define live
    #[pure] // can be used in specifications
    // TODO: add spec (pre)
    fn get(&self, index: usize) -> i32 {
      42 // TODO: implement
    }





    #[pure] // can be used in specifications
    fn sorted(&self) -> bool {
      true // TODO: implement
    }

} 


#[ensures="a.get(0) == old(a.get(0))"] // could be strengthened
#[ensures="old(a.sorted()) ==> (old(a.get(a.len() - 1)) <= v ==> a.sorted())"] // sortedness preserved
fn append(a: &mut List, v: i32) {
    if let Some(box ref mut tail) = a.next {
        append(tail, v); 
    } else {
        a.next = Some(box List {
            val: v,
            next: None
        });
    }
}
